/**
 * mdc2lst :
 * 	a tcl interface to C parsing functions.
 *	used to create a tcl list representing a Manuel de Codage text.
 */

#include <tcl.h>
#include "general.h"
#include "fordll.h"

EXTERN EXPORT(int,Mdc2lst_Init) _ANSI_ARGS_((Tcl_Interp *interp));

PRIVATE int
Mdc2lst_parseMDC(ClientData clientData,
									Tcl_Interp *interp,
									int objc,
									struct Tcl_Obj * CONST objv[])
{
	Tcl_Obj * res;
	if (objc < 2)
		{
			Tcl_AppendResult(interp, Tcl_GetString(objv[0]), " FontFilename", (char *) NULL);
			return TCL_ERROR;
		}
	
	
	
	if (read_font(interp, Tcl_GetString(objv[1]), &res) == TCL_OK)
		{
			Tcl_SetObjResult(interp, res);
			return TCL_OK;
		}
	else
		{
			Tcl_AppendResult(interp, Tcl_GetString(objv[1]), " does not contain a proper bzr font", (char *) NULL);
			return TCL_ERROR;
		}
}


EXPORT(int,Mdc2lst_Init)(interp)
     Tcl_Interp *interp;
{

  Tcl_CreateObjCommand(interp, 
											 "mdc2lst::parseMDC",
											 Mdc2lst_parseMDC,
											 (ClientData)NULL, 
											 (Tcl_CmdDeleteProc*) NULL);

	return Tcl_PkgProvide(interp, "Mdc2lst", "1.0");
 }

/*
 * Local Variables:
 * tab-width: 2
 * End:
 */

