%{
  /*
   *  Heavily revised version of seshl.l for the lemon based
   *  Manuel de Codage parser for TCL.
   *
   *  This parser builds a Tcl_Obj
   *
   *  Unnecessary code removed.
   */
  
#define _POSIX_SOURCE 1

#include <string.h>
#include <strings.h>
#include <stdio.h>
#include <tcl.h>
#include "general.h"
#include "TclListUtils.h"
#include "gram.h"

/* 
   The system to handle more than one file in yylex is
   not THAT elegant.
   to restart: yyrestart( yyin);
*/

#ifndef YY_NULL
#define YY_NULL 0
#endif

#undef YY_INPUT
#define YY_INPUT(buf,result,max_size) { result = do_array_read(buf);}

#undef YYLMAX
#define YYLMAX 10240

#define startState(x) BEGIN(x); seshLexerState.state= INITIAL;

#include "seshlcode.c"

#define DO_SYMBOL(x) signWasRead(); setTextVal(x); return SYMBOL

%}

NATURAL	([0-9]+)
INTEGER	(-?{NATURAL})
gardiner	(([A-Z]|Aa){NATURAL}a*)
ident	([@a-zA-Z0-9.'`]+)
ESPS	([ \t\n\015_]+)
ESPSO	([ \t\n\015_-]*)
ESP	([ \t\n\015_])
SEPSO	([\t\n\015-]*)
ROMTXT	([^+]|"+"[^lsjbict+])


%x DEFINE0 DEFINE1 HieroText COMMENTAIRE LIGNECOM
%e 2000

%%
	startState(HieroText);
                                        updateSignRead();

<HieroText>^"@GLYPH".*
<HieroText>{ident}	{
	  signWasRead();
	  setTextVal(yytext);
                                          return HIEROGLYPH;
	}

<HieroText>{ESPS}	|
<HieroText>"_"	|
<HieroText>"__"	{TLINE(); return  WORDEND;}
<HieroText>"+s"{ESPSO}	{TLINE();}
<HieroText>"="	return GRAMMAR;
<HieroText>"-"?"!="{INTEGER}"%"[\n\015 \t=-]*            |
<HieroText>"-"?"!"[\n \015\t=-]*	{
                                          TLINE();
                                          return LINEEND;
                                        }
<HieroText>"-"?"!!="{INTEGER}"%"[\n\015 \t=-]*            |
<HieroText>"-"?"!!"[\n \015\t=-]*	{
                                          TLINE();
                                          return PAGEEND;
                                        }
<HieroText>"-"{ESPSO}	{TLINE();
                                         return SEPARATOR;
                                        }
<HieroText>":"{ESPSO}	{TLINE(); return COLUMN;}
<HieroText>"*"{ESPSO}	{TLINE(); return STAR;}
<HieroText>"&"{ESPSO}	|
<HieroText>"&&"{ESPSO}	{TLINE(); return AMP;}
<HieroText>"+j"{ROMTXT}*	|
<HieroText>"+b"{ROMTXT}*	|
<HieroText>"+i"{ROMTXT}*	|
<HieroText>"+c"{ROMTXT}*	|
<HieroText>"+t"{ROMTXT}*	|
<HieroText>"+l"{ROMTXT}*	{TLINE();
	 setTextVal(yytext + 2);
	 return TEXT;
	}
<HieroText>"+dg"	{return TOGGLE;}
<HieroText>"+gd"	{return TOGGLE;}
<HieroText>"+lr"	{return TOGGLE;}
<HieroText>"+rl"	{return TOGGLE;}
<HieroText>"|"[^-]+	{ setTextVal(yytext+1);
	  return TEXTSUPER;
	}
<HieroText>\\!	;
<HieroText>{SEPSO}"."{ESPSO}	{return SYMBOL;}
<HieroText>{SEPSO}".."{ESPSO}	{return SYMBOL;}
<HieroText>"//"{ESPSO}	{DO_SYMBOL("f");}
<HieroText>"h/"{ESPSO}	{DO_SYMBOL("h");}
<HieroText>"v/"{ESPSO}	{DO_SYMBOL("v");}
<HieroText>"/"{ESPSO}	{DO_SYMBOL("q");}
<HieroText>"^"{ESPSO}	{};
<HieroText>"?"{ESPSO}	{};
<HieroText>"??"{ESPSO}	{};
<HieroText>"[{"{ESPSO}	{return BEGINPHIL;}
<HieroText>"}]"{ESPSO}	{return ENDPHIL;}
<HieroText>"[["{ESPSO}	{return BEGINPHIL;}
<HieroText>{SEPSO}"]]"{ESPSO}	{return ENDPHIL;}
<HieroText>"[\""{ESPSO}	{return BEGINPHIL;}
<HieroText>{SEPSO}"\"]"{ESPSO}	{return ENDPHIL;}
<HieroText>"['"{ESPSO}	{return BEGINPHIL;}
<HieroText>{SEPSO}"']"{ESPSO}	{return ENDPHIL;}
<HieroText>"[&"{ESPSO}	{return BEGINPHIL;}
<HieroText>{SEPSO}"&]"{ESPSO}	{return ENDPHIL;}
<HieroText>"<"{ESPSO}	{return BEGINOLDCARTOUCHE;}
<HieroText>"<"h?[1-3]{ESPSO}	
<HieroText>"<b"{ESPSO}	
<HieroText>"<m"{ESPSO}	
<HieroText>"<e"{ESPSO}	
<HieroText>{SEPSO}">"{ESPSO}	
<HieroText>{SEPSO}[HhsSfF]?[1-3]">"{ESPSO}
<HieroText>"<S"{ESPSO}	{}
<HieroText>"<S"[1-3]{ESPSO}	{}
<HieroText>"<F"{ESPSO}	{}
<HieroText>"<H"{ESPSO}	{}
<HieroText>"<H"[1-3]{ESPSO}	{}
<HieroText>"<Sb"{ESPSO}	
<HieroText>"<Sm"{ESPSO}	
<HieroText>"<Se"{ESPSO}	
<HieroText>"<Fb"{ESPSO}	
<HieroText>"<Fm"{ESPSO}	
<HieroText>"<Fe"{ESPSO}	
<HieroText>"<Hb"{ESPSO}	
<HieroText>"<Hm"{ESPSO}	
<HieroText>"<He"{ESPSO}	
<HieroText>"#"	{return OVERWRITE;}
<HieroText>"# "	
<HieroText>{SEPSO}"#-"{ESPSO}           |
<HieroText>{SEPSO}"-#"{ESPSO}           |
<HieroText>"-#-"	
<HieroText>{SEPSO}"#b"{ESPSO}                  {if (signe_lu) REJECT; dieze=1-dieze; return DIEZE;}
<HieroText>{SEPSO}"#b"{ESPSO}                  {dieze=1-dieze; return DIEZE;}
<HieroText>{SEPSO}"#e"{ESPSO}                  {dieze=1-dieze; return DIEZE;}
<HieroText>"#"?"#"[1-4]+{ESPSO}	

<HieroText>{SEPSO}"$"{ESPSO}	{couleur=1-couleur;
	  if (couleur==1) return RED;
	  else return BLACK;}
<HieroText>{SEPSO}"$b"{ESPSO}                   {couleur=1; return BLACK;}
<HieroText>{SEPSO}"$r"{ESPSO}                   {couleur=0; return RED;}
<HieroText>\\	{return REVERT;}
<HieroText>\\s[0-9]	{
                                          int s=  atoi(yytext+2); 
                                          s= 100 / (1+s);
                                          seshlval.un_entier= s;
                                          return SIZE;  
                                        }
<HieroText>\\{INTEGER}	{
                                          seshlval.un_entier= atoi(yytext+1); 
                                          return SIZE;  
                                        }
<HieroText>\\R{INTEGER}	{
                                          seshlval.un_entier= atoi(yytext+2); 
                                          return ROTATION;  
                                        }
<HieroText>\\r[1-4]	{
                                          seshlval.un_entier= atoi(yytext+2) * 90; 
                                          return ROTATION;  
                                        }
<HieroText>\\t[1-4]	{
                                          seshlval.un_entier= atoi(yytext+2) * 90; 
                                          return NROTATION;  
                                        }
<HieroText>"++"                         BEGIN(COMMENTAIRE);
<HieroText>{SEPSO}"+s"{ESPSO}
<HieroText>"("{ESPSO}	return '(';
<HieroText>")"{ESPSO}	return ')';
<HieroText>(.)	return yytext[0];


<COMMENTAIRE>{ROMTXT}*	BEGIN(HieroText);
<LIGNECOM><<EOF>>	yyterminate();
<LIGNECOM>(.|\n)	{yymore(); }
<LIGNECOM>"+s"{ESPSO}	{TLINE();
	seshlval.une_chaine= 
                                           enleve_plus_a_la_fin(dupliquechaine(yytext));
	return LIGNE_COMMENTAIRE;
	}
\015                                    ;

<HieroText>"{"[lL]{entier}","{entier}"}"
<HieroText>"{{"{entier}","{entier}","{entier}"}}"
<HieroText>"/h"
<HieroText>"/s"
<HieroText>"/v"

%%

/* 
 * Local Variables:
 * mode: c
 * tab-width: 40
 * header: "seshaux.h"
 * End:
 */
