/* 
	 Data structure for fonts.
*/
#ifndef BFONT_H
#define BFONT_H 
#include "tgraph.h"
#include "tcl.h"

#define CHRINFONT 256
#define MAXPTS 16

typedef struct Contour_struct {
	enum senscontour {positif, negatif, nofill, trait} type;
	int nbr_pts;
	TKSESH_point * virtuel_trace, * scaled_trace;
	struct Contour_struct 
		*next;
} Contour;

typedef struct Lettre_struct {
	unsigned char code;
	struct BFont_struct *font;
	int loaded;										/* is the character loaded ? */
	int defined;									/* has the character got a definition ? */
	double width;
	double llx, lly, urx, ury;
	Contour * contours;
} Lettre;

/* structures for storing fonts */

typedef struct BFont_struct {
	char * name; 
	char * filename;
	unsigned long int post;				/* pointeur sur le premier pointeur de char */
	double size;
	Lettre lettres[CHRINFONT];
} BFont;


extern BFont* 
BZR_read(char *name);

void  
BZR_putc(Lettre *l,
				 double sizex,
				 double sizey,
				 int angle,
				 int revert,
				 TKSESH_output *ouca,
				 TKSESH_point where);

double 
BZR_charWidth(Lettre *l);

double 
BZR_charHeight(Lettre *l);

/* int
	 set_lettre(Tcl_Interp *interp, 
	 Lettre *l, 
	 Tcl_Obj *rep);
*/

#endif

/*
 * Local Variables:
 * tab-width: 2
 * End:
 */

