/* bzr_opcodes.h: symbolic names for the BZR commands.  We have the
   luxury here of choosing any values for the opcodes, so we may as well
   be a little mnemonic about it.
   
Copyright (C) 1992 Free Software Foundation, Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#ifndef BZR_OPCODES_H
#define BZR_OPCODES_H

/* Beginning of character. 
   followed by : width llx lly urx ury
*/
#define BOC		'b'
#define BOC_ABBREV	'B'

/* font ending ID */
#define BZR_ID		'K'
/* char location identifier.
   Followed by char code and char position
   */
#define CHAR_LOC	'c'
#define CHAR_LOC_ABBREV	'C'
/* EOC : end of char */
#define EOC		'e'
/* line segment */
#define LINE		'l'
#define LINE_ABBREV	'L'
/* do nothing code */
#define NO_OP		'x'
/* postamble code */
#define POST		'P'
#define POST_POST	'Q'
/* sline segment */
#define SPLINE		's'
#define SPLINE_ABBREV	'S'
/* new path definition */
#define START_PATH	'p'

/* Extension for screen font and the like */

/* 
 * non filling stroke.
 */
#define START_CURVE		't'

/*
 * non filling closed path
 */
#define START_NOFIL		'O'

/* (future use : pen strike
* line plus varying line width and pen orientation 
*/
#define START_STRIKE		'g'
/*
 * self-explanatory
 */
#define CIRCLE		'o'

#endif /* not BZR_OPCODES_H */
