%{
/*$Id: seshl.l,v 1.1.1.1 2002/04/16 13:55:00 rosmord Exp $ */

#define _POSIX_SOURCE 1

#include "general.h"
#include "duplique.h"
#include "signs.h"

/* 
   The system to handle more than one file in yylex is
   not THAT elegant.
   to restart: yyrestart( yyin);
*/

static char * char_entry_id;

#ifndef YY_NULL
#define YY_NULL 0
#endif

#undef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
{\
    result = do_array_read(buf);\
}

/**
  prepare to read string
  in a parser
 */

PUBLIC void
init_array_read(char *s)
{
  char_entry_id= s;
}

PRIVATE int 
do_array_read(char *buf)
{
  int c;
  c= *(char_entry_id++);
  return (c == 0 ? YY_NULL : (buf[0] = c, 1));
}

#include "quadra.h"
#include "mdctexte.h"
#include "mdccoord.h"
#include "sesh.h"
#include "hache.h"
#include "seshaux.h"
#include "ligatur.h"

/* 
   Coordinates
*/

Coordinate_System * current_coordinate_system = NULL;

#undef YYLMAX
#define YYLMAX 10240
#include <string.h>
#include <strings.h>
#include <stdio.h>

#define Commence(x) BEGIN(x); etat=x;

extern int signe_trouve;

PRIVATE void
calcule_hachures(Hachures *h);

char * nomdefine;

int dieze=0;
int couleur=1;
int signe_lu= FALSE;
int signe_deja_lu= FALSE;
int etat= INITIAL;
extern int seshnumligne;

PRIVATE void
TLIGNE();

PRIVATE char *
enleve_plus_a_la_fin(char *s);

%}

entier	([0-9]+)
INTEGER	(-?{entier})
gardiner	(([A-Z]|Aa){entier}a*)
ident	([@a-zA-Z0-9.'`]+)
ESPS	([ \t\n\015_]+)
ESPSO	([ \t\n\015_-]*)
ESP	([ \t\n\015_])
SEPSO	([\t\n\015-]*)
ROMTXT	([^+]|"+"[^lsjbict+])


%x DEFINE0 DEFINE1 HieroText COMMENTAIRE LIGNECOM
%e 2000

%%
	Commence(HieroText);
                                        if ( signe_lu )
                                        {
                                           if (signe_deja_lu) 
                                              {signe_deja_lu = FALSE; signe_lu= FALSE; }
                                           else
                                              {signe_deja_lu= TRUE;}
                                        }
<HieroText>^"@GLYPH".*
<HieroText>"o"	{seshlval.une_donnee= seshtrouvesigne(yytext); return POINTROUGE;}
<HieroText>"O"	{seshlval.une_donnee= seshtrouvesigne("o"); return POINTNOIR;}

<HieroText>{ident}	|
<HieroText>([A-Z]|Aa){entier}A*	{seshlval.une_donnee=
                                                 seshtrouvesigne(yytext); 
	  if (!signe_trouve) {REJECT } 
	  else {signe_lu= TRUE; return HIEROGLYPHE;}
	}

<HieroText>{ESPS}	{TLIGNE(); return  FINMOT;}
<HieroText>"_"	{TLIGNE(); return  FINMOT;}
<HieroText>"__"	{TLIGNE(); return  FINMOT;}
<HieroText>"+s"{ESPSO}
<HieroText>"="	return GRAMMAIRE;
<HieroText>"-"?"!="{INTEGER}"%"[\n\015 \t=-]*            |
<HieroText>"-"?"!"[\n \015\t=-]*	{
                                          TLIGNE(); 
                                          seshlval.un_separateur= S_finligne;
                                          return FIN_LIGNE;
                                        }
<HieroText>"-"?"!!="{INTEGER}"%"[\n\015 \t=-]*            |
<HieroText>"-"?"!!"[\n \015\t=-]*	{
                                          TLIGNE();
                                          seshlval.un_separateur= S_finpage;
                                          return FIN_PAGE;
                                        }
<HieroText>{ESPSO}"++COORDS="([^+]|"+"[^+])*"+s"{ESPSO} {
                     char *toto= dupliquechaine(strchr(yytext, '=')+1);
                     enleve_plus_a_la_fin(toto);
                     TLIGNE();
                     set_text_coordinate(current_coordinate_system, 
                                         toto, seshlval.des_coordonnees.coords);
                     seshlval.des_coordonnees.descr= dupliquechaine(toto);
                     LIBERE(toto);
                     return FIXE_LIGNE;
                                                         }
<HieroText>{ESPSO}"++TXT"	BEGIN(LIGNECOM);
<HieroText>"-"{ESPSO}	{TLIGNE();
                                          seshlval.un_separateur= S_intersignes; 
                                          return SEPARATEUR;
                                        }
<HieroText>":"{ESPSO}	{TLIGNE(); return ':';}
<HieroText>"*"{ESPSO}	{TLIGNE(); return '*';}
<HieroText>"&"{ESPSO}	{TLIGNE(); return '&';}
<HieroText>"&&"{ESPSO}	{TLIGNE(); return '&';}
<HieroText>"+j"{ROMTXT}*	|
<HieroText>"+b"{ROMTXT}*	|
<HieroText>"+i"{ROMTXT}*	|
<HieroText>"+c"{ROMTXT}*	|
<HieroText>"+t"{ROMTXT}*	|
<HieroText>"+l"{ROMTXT}*	{TLIGNE();
                                          seshlval.une_donnee.texte= 
                                             dupliquechaine(yytext + 2);
	  return ROMAIN;
	}
<HieroText>"+dg"	return DROITEGAUCHE;
<HieroText>"+gd"	return GAUCHEDROITE;
<HieroText>"+lr"	return LEFTRIGHT;
<HieroText>"+rl"	return RIGHTLEFT;
<HieroText>"|"[^-]+	{seshlval.une_donnee.texte= dupliquechaine(yytext+1);
	  return TEXTESUPER;
	}
<HieroText>\\!	return KERNING;
<HieroText>{SEPSO}"."{ESPSO}	return POINT;
<HieroText>{SEPSO}".."{ESPSO}	return POINTPOINT;
<HieroText>"//"{ESPSO}	{signe_lu= TRUE; return HACHUREG;}
<HieroText>"h/"{ESPSO}	{signe_lu= TRUE; return HACHUREH;}
<HieroText>"v/"{ESPSO}	{signe_lu= TRUE; return HACHUREV;}
<HieroText>"/"{ESPSO}	{signe_lu= TRUE; return HACHURET;}
<HieroText>"^"{ESPSO}	return HAPLOGRAPHIE;
<HieroText>"?"{ESPSO}	return LACUNE;
<HieroText>"??"{ESPSO}	return  LIGNELACUNE;
<HieroText>"[{"{ESPSO}	{TLIGNE(); return DSTSUPERFETATOIRE;}
<HieroText>"}]"{ESPSO}	{TLIGNE(); return FSTSUPERFETATOIRE;}
<HieroText>"[["{ESPSO}	{TLIGNE(); return DSTEFFACE;}
<HieroText>{SEPSO}"]]"{ESPSO}	{TLIGNE(); return FSTEFFACE;}
<HieroText>"[\""{ESPSO}	{TLIGNE(); return  DSTDISPARU ;}
<HieroText>{SEPSO}"\"]"{ESPSO}	{TLIGNE(); return  FSTDISPARU ;}
<HieroText>"['"{ESPSO}	{TLIGNE(); return  DSTRAJOUTSCRIBE;}
<HieroText>{SEPSO}"']"{ESPSO}	{TLIGNE(); return  FSTRAJOUTSCRIBE;}
<HieroText>"[&"{ESPSO}	{TLIGNE(); return  DSTRAJOUTAUTEUR;}
<HieroText>{SEPSO}"&]"{ESPSO}	{TLIGNE(); return  FSTRAJOUTAUTEUR;}
<HieroText>"<"{ESPSO}	{TLIGNE(); seshlval.un_typegroupe= S_carto; return DEBUTCONSTRUCTION;}
<HieroText>"<"h?[1-3]{ESPSO}	{TLIGNE(); seshlval.un_typegroupe= S_carto; return DEBUTCONSTRUCTION;}
<HieroText>"<b"{ESPSO}	{TLIGNE(); seshlval.un_typegroupe= S_debcarto; return DEBUTCONSTRUCTION;}
<HieroText>"<m"{ESPSO}	{TLIGNE(); seshlval.un_typegroupe= S_milcarto; return DEBUTCONSTRUCTION;}
<HieroText>"<e"{ESPSO}	{TLIGNE(); seshlval.un_typegroupe= S_fincarto; return DEBUTCONSTRUCTION;}
<HieroText>{SEPSO}">"{ESPSO}	{TLIGNE(); return CARTF;}
<HieroText>{SEPSO}[HhsSfF]?[1-3]">"{ESPSO}	{TLIGNE(); return CARTF;}
<HieroText>"<S"{ESPSO}	{TLIGNE(); seshlval.un_typegroupe= S_serekh; return DEBUTCONSTRUCTION;}
<HieroText>"<S"[1-3]{ESPSO}	{TLIGNE(); seshlval.un_typegroupe= S_serekh; return DEBUTCONSTRUCTION;}
<HieroText>"<F"{ESPSO}	{TLIGNE(); seshlval.un_typegroupe= S_enceinte; return DEBUTCONSTRUCTION;}
<HieroText>"<H"{ESPSO}	{TLIGNE(); seshlval.un_typegroupe= S_chateau; return DEBUTCONSTRUCTION;}
<HieroText>"<H"[1-3]{ESPSO}	{TLIGNE(); seshlval.un_typegroupe= S_chateau; return DEBUTCONSTRUCTION;}
<HieroText>"<Sb"{ESPSO}	{TLIGNE(); seshlval.un_typegroupe= S_debserekh; return DEBUTCONSTRUCTION;}
<HieroText>"<Sm"{ESPSO}	{TLIGNE(); seshlval.un_typegroupe= S_milserekh; return DEBUTCONSTRUCTION;}
<HieroText>"<Se"{ESPSO}	{TLIGNE(); seshlval.un_typegroupe= S_finserekh; return DEBUTCONSTRUCTION;}
<HieroText>"<Fb"{ESPSO}	{TLIGNE(); seshlval.un_typegroupe= S_debenceinte; return DEBUTCONSTRUCTION;}
<HieroText>"<Fm"{ESPSO}	{TLIGNE(); seshlval.un_typegroupe= S_milenceinte; return DEBUTCONSTRUCTION;}
<HieroText>"<Fe"{ESPSO}	{TLIGNE(); seshlval.un_typegroupe= S_finenceinte; return DEBUTCONSTRUCTION;}
<HieroText>"<Hb"{ESPSO}	{TLIGNE(); seshlval.un_typegroupe= S_debchateau; return DEBUTCONSTRUCTION;}
<HieroText>"<Hm"{ESPSO}	{TLIGNE(); seshlval.un_typegroupe= S_milchateau; return DEBUTCONSTRUCTION;}
<HieroText>"<He"{ESPSO}	{TLIGNE(); seshlval.un_typegroupe= S_finchateau; return DEBUTCONSTRUCTION;}
<HieroText>"##"	{return OVERWRITE;}
<HieroText>"#"	{return OVERWRITE;}
<HieroText>"# "	{seshlval.des_hachures= TOUTHACHURE; return HACHURES;}
<HieroText>{SEPSO}"#-"{ESPSO}           |
<HieroText>{SEPSO}"-#"{ESPSO}           |
<HieroText>"-#-"	{return DIEZE;}
<HieroText>{SEPSO}"#b"{ESPSO}                  {if (signe_lu) REJECT; dieze=1-dieze; return DIEZE;}
<HieroText>{SEPSO}"#b"{ESPSO}                  {dieze=1-dieze; return DIEZE;}
<HieroText>{SEPSO}"#e"{ESPSO}                  {dieze=1-dieze; return DIEZE;}
<HieroText>"#"?"#"[1-4]+{ESPSO}	{calcule_hachures(&(seshlval.des_hachures));
	 return HACHURES;}

<HieroText>{SEPSO}"$"{ESPSO}	{couleur=1-couleur; /* ne compliquons pas la grammaire */
	  if (couleur==1) return RED;
	  else return BLACK;}
<HieroText>{SEPSO}"$b"{ESPSO}                   {couleur=1; return BLACK;}
<HieroText>{SEPSO}"$r"{ESPSO}                   {couleur=0; return RED;}
<HieroText>\\	{return REVERT;}
<HieroText>\\i	{return IGNORE;}
<HieroText>\\l	{seshlval.un_entier= 1; return LONGSIGN;}
<HieroText>\\l[01]	{seshlval.un_entier= yytext[2] - '0' ; return LONGSIGN;}
<HieroText>\\w	{seshlval.un_entier= 1; return WIDECADRAT;}
<HieroText>\\w[01]	{seshlval.un_entier= yytext[2] - '0' ; return WIDECADRAT;}
<HieroText>\\s[0-9]	{
                                          int s=  atoi(yytext+2); 
                                          s= 100 / (1+s);
                                          seshlval.un_entier= s;
                                          return SIZE;  
                                        }
<HieroText>\\{INTEGER}	{
                                          seshlval.un_entier= atoi(yytext+1); 
                                          return SIZE;  
                                        }
<HieroText>\\R{INTEGER}	{
                                          seshlval.un_entier= atoi(yytext+2); 
                                          return ROTATION;  
                                        }
<HieroText>\\r[1-4]	{
                                          seshlval.un_entier= atoi(yytext+2) * 90; 
                                          return ROTATION;  
                                        }
<HieroText>\\t[1-4]	{
                                          seshlval.un_entier= atoi(yytext+2) * 90; 
                                          return NROTATION;  
                                        }
<HieroText>"++"                         BEGIN(COMMENTAIRE);
<HieroText>{SEPSO}"+s"{ESPSO}
<HieroText>"("{ESPSO}	return '(';
<HieroText>")"{ESPSO}	return ')';
<HieroText>(.)	return yytext[0];


<COMMENTAIRE>{ROMTXT}*	BEGIN(HieroText);
<LIGNECOM><<EOF>>	yyterminate();
<LIGNECOM>(.|\n)	{yymore(); }
<LIGNECOM>"+s"{ESPSO}	{TLIGNE();
	seshlval.une_chaine= 
                                           enleve_plus_a_la_fin(dupliquechaine(yytext));
	return LIGNE_COMMENTAIRE;
	}
\015                                    ;
<HieroText>{ident}	|
<HieroText>([A-Z]|Aa){entier}A*	{
                                          seshlval.une_donnee.texte= dupliquechaine(yytext);
	  signe_lu= TRUE; return INCONNU;
	}

<HieroText>"{"[lL]{entier}","{entier}"}"
<HieroText>"{{"{entier}","{entier}","{entier}"}}"
<HieroText>"/h"
<HieroText>"/s"
<HieroText>"/v"
<HieroText>"["	return '[';
<HieroText>"]"	return ']';
%%

/**
* sets the current coordinate system
*/

PUBLIC void
sesh_set_coordinate_system(Coordinate_System *c)
{
  current_coordinate_system= c;
}

PRIVATE void
calcule_hachures(Hachures *h)
{
  int i;
  *h= NOHACHURE;
  for (i=1; i< yyleng; i++)
    switch(yytext[i])
      {
      case '1':
        *h |= HACHURE1;
        break;
      case '2':
        *h |= HACHURE2;
        break;
      case '3':
        *h |= HACHURE3;
        break;
      case '4':
        *h |= HACHURE4;
        break;
      }
}

PRIVATE void
TLIGNE()
{
  char *s;
  s= yytext;
  while ((s= strchr(s, '\n')))
  {
    seshnumligne++;
    s++;
  }
}

PRIVATE char *
enleve_plus_a_la_fin(char *s)
{
  char *fin;
  fin= s + strlen(s) - 1;
  while ((*fin) != '+') fin--;
  while ((*fin) == '+') fin--;
  fin++;
  *fin= 0;
  return s;
}

/**
 * The classic yywrap function.
 * 
 */

int
yywrap()
{
  return 1;
}

/**
 * Initialisation
 */

PUBLIC void
SESH_init_seshlex()
{
  dieze=0;
  couleur=1;
  signe_lu= FALSE;
  signe_deja_lu= FALSE;
  etat= INITIAL;
  yyrestart( yyin );
}

/* 
 * Local Variables:
 * mode: c
 * tab-width: 40
 * header: "seshaux.h"
 * End:
 */
