# This file adds the possibility to bind an action to 
# the image part of a tab in a notebook, for instance to close the tab.

# To make it work, I modify the line :
#	    set id [$path.c create image $ximg $ytext -anchor nw 
#		     -tags   [list page p:$page $page:img]]
# in notebook.tcl, adding "image" between p:$page and $page:img

package provide BWidgetBindImage 1.0

namespace eval NoteBook {
    proc bindimages {path event script} {
	if { $script != "" } {
	    $path.c bind "image" $event \
		"$script \[string range \[lindex \[$path.c gettags current\] 1\] 2 end\]"
	} else {
	    $path.c bind "image" $event {}
	}
    }
}
#	    $path.c bind $page:img <ButtonPress-1> "$path delete $page"
