
# First version of the Text Database browser.
# Currently, we use "static" functions to
# access the text database.
# A move to more object orientation would be nice.


package require tclSQLDB
package require myStoopWidgets
package require tkDB

package provide DBBrowsers 1.0

class TextDBBrowser {
    
    set (singleton) 0

    
    proc TextDBBrowser {this name} \
	STopLevel {$name} {
	    #set ($this,workflow) $workflow
	    setTarget $this .w
	}
    
    proc ~TextDBBrowser {this} {
    }

    # Sets the sesh widget which will load the text
    # Currently, this widget is designated by a path.
    proc setTarget {this target} {
	set ($this,seshw) $target
    }

    proc getTarget {this} {
	return $($this,seshw)
    }

    proc showBrowser {} {
	if { $(singleton) == 0} {
	    set (singleton) [STopLevel::buildNewTopLevel TextDBBrowser textBrowser]
	}
	set (singleton) 0
    }

    virtual proc completorHook {this} {
	set ds [seshtext::getTextNamesDataSource]
	#set ds [TkseshWorkflow::getTextListDataSource $($this,workflow)]
	set ($this,browser) [Component::buildNewComponent BDBBrowser $this -auto \
				 $ds {name}]

	set p [Component::getPath $this]
	button $p.cancel -text [legendes::trans "Cancel"] \
	    -command [list TextDBBrowser::cancel $this]
	grid [Component::getPath $($this,browser)] -sticky news
	grid $p.cancel -sticky ew
	grid rowconfigure $p 0 -weight 1
	grid columnconfigure $p 0 -weight 1
	
	BDBBrowser::setCaseSensitive $($this,browser) 0
	BDBBrowser::setCommand $($this,browser) [list TextDBBrowser::loadCommand $this]
    }

    proc cancel {this} {
	close $this
    }
    
    proc loadCommand {this idx} {
	
	set pb [STopLevel::buildNewTopLevel \
		    SProgressWindow progressbar [legendes::trans "Loading text"]]
	
	TkseshDB::begin [TkseshDB::getTkseshDB]
	catch {
	    set txt [seshtext::getMDCTextFromListIdx $idx]
	    seshw::fromtext [getTarget $this] $txt $pb
	}
	TkseshDB::commit [TkseshDB::getTkseshDB]
	close $this

	delete $pb
    }

    proc close {this} {
	delete $this
	set (singleton) 0
    } 
    
}


#    set browserFrame [Component::buildNewComponent STopLevel textchoser]
#    set browserWindow [Component::buildNewComponent BDBBrowser $browserFrame -auto]
#dbbrowse::create $w.l -head hie -idx texts
#dbbrowse::setload $w.l chosedtextloader
#dbbrowse::setfirst $w.l 0
#    set w [Component::getPath $browser]
#    button $w.close -text [legendes::trans "Cancel"] -command [list destroy $w]
#grid $w.l -sticky news
#    grid $w.close -sticky ew 
#    grid rowconfigure $w 0 -weight 1
#    grid columnconfigure $w 0 -weight 1
#bind $w.l.list <Delete> [list deleteMyText $w]
#     catch {
# 	set name [dbfilesel::getname -ext hie]
# 	seshw::gettext .w $name
#     }
