# Dictionary Browser workflow

# Current organization :

package provide seshDico 0.0

package require tkDB
package require tkseshUtils

class DicoBrowserWF {

    proc DicoBrowserWF {this dicoBrowser}  {
	set (this,dicoBrowser) $dicoBrowser
	setTranslation $this ""
	setTranslitteration $this ""
	setHieroglyphs $this ""
	set ($this,subwNum) 0
    }

    proc ~DicoBrowserWF {this} {
    }

    proc getDataSource {this} {
	return [DicoDAL::getDataSource]
    }

    proc setHieroglyphs {this txt} {
	set ($this,hieroglyphs) $txt
    }
    
    proc setTranslation {this txt} {
	set ($this,translation) $txt
    }

    proc setTranslitteration {this txt} {
	set ($this,translitteration) $txt
    }

    proc setSubSearch {this v} {
	set ($this,subSearch) $v
    }

    proc getSubSearch {this} {
	return $($this,subSearch)
    }

    proc setAndSearch {this v} {
	set ($this,andSearch) $v
    }

    proc getAndSearch {this} {
	return $($this,andSearch)
    }

    proc getHieroglyphs {this} {
	return $($this,hieroglyphs)
    }
    
    proc getTranslation {this} {
	return $($this,translation)
    }

    proc getTranslitteration {this} {
	return $($this,translitteration)
    }

    # search in the dictionary according to the current values
    # Currently, we do an exact search, with an implicit "or"
    proc find {this} {
	set result [list]
	# tcl trick : eval is used to expand the lists returned by findEntriesByIndex.
	# we could have used a loop instead.
	set sub [getSubSearch $this]
	set trlit [DicoWF::findEntriesByIndex MTRI [getTranslitteration $this] $sub]
	set hieros [DicoWF::findEntriesByIndex WRI [getHieroglyphs $this] $sub]
	set trlat [DicoWF::findEntriesByIndex TRAD [getTranslation $this] $sub]
	if {[getAndSearch $this]} {
	    set l [list]
	    if {[getHieroglyphs $this] ne ""} {
		lappend l $hieros
	    }
	    if {[getTranslitteration $this] ne ""} {
		lappend l $trlit
	    }
	    if {[getTranslation $this] ne ""} {
		lappend l $trlat
	    }
	    if {[llength $l] == 0} {return [list]}
	    set result [lindex $l 0]
	    foreach i [lrange $l 1 end] {
		set result [TkseshUtils::computeSetIntersection $result $i]
	    }
	} else {
	    eval lappend result $trlit $hieros $trlat
	}
	return $result
    }

    proc getOIDForID {this idx} {
	set r [DicoDAL::getOIDForID $idx]
	return $r
    }

    proc buildSimpleEntry {this} {
	set internal [list]
	if {[getHieroglyphs $this] ne ""} {
	    lappend internal [list WRI [getHieroglyphs $this]]
	}
	if {[getTranslitteration $this] ne ""} {
	    lappend internal [list MTRI [getTranslitteration $this]]
	}
	if {[getTranslation $this] ne ""} {
	    lappend internal [list TRAD [getTranslation $this]]
	}
	return [list GRP $internal]
    }
    
    proc getNewTopName {this} {
	incr ($this,subwNum)
	return "dico$($this,subwNum)"
    }
}
