#
# Widget to display and manage the tksesh font database.
#
package require seshw
package require tablelist
class CharDBValueEditor {
    
    proc CharDBValueEditor {this parent appli name wf args} SScrolledWindow {$parent $name $args} Observer {} {
	set ($this,appli) $appli
	set ($this,wf) $wf
	Observable::add $($this,wf) $this
    }

    proc ~CharDBValueEditor {this} {
	delete $($this,scrollArea)
	delete $($this,tableScroll)
	delete $($this,frame)
	delete $($this,code)
	delete $($this,table)
	delete $($this,valueNavigator)
	delete $($this,value)
    }

    virtual proc creatorHook {this} {
	SScrolledWindow::_creatorHook $this
    }
    
    proc getImageName {this} {
	return Image.$this
    }

    virtual proc completorHook {this} {
	set wf $($this,wf)
	# This object is a window which can contain one scrollable thing
	# (a canvas, for instance)
	# So we put a scrollable frame in it.	
	
	set scrollArea [Component::buildNewComponent SScrollableFrame $this -auto -areawidth 0]
	set ($this,scrollArea) $scrollArea
	SScrolledWindow::setWidget $this $scrollArea

	set ($this,frame) [FrameContainer::getFrame $scrollArea]
	
	set p [Component::getPath $($this,frame)]
	set img [image create bitmap [getImageName $this]]
	

	set ($this,drawingFrame) $p.glyphDraw
	frame $($this,drawingFrame) -width 100 -height 100

	set valueDS [CharDBWorkflow::getValueDS $wf]
	set codeDS [CharDBWorkflow::getCodeDS $wf]


	set ($this,code) \
	    [Component::buildNewComponent BDBField $($this,frame) code $codeDS "code" -editable 0]
	
	# create scrollbars for the table representation below.
	set ($this,tableScroll) \
	    [Component::buildNewComponent SScrolledWindow $($this,frame) -auto]
	
	set ($this,table) \
	    [Component::buildNewComponent BDBTableList $($this,frame) -auto \
		 $valueDS {uid value valueType usualValue usualSign period} \
		 -activestyle frame -takefocus 1 -height 4]

	SScrolledWindow::setWidget $($this,tableScroll) $($this,table)
	
	set ($this,valueNavigator) \
	    [Component::buildNewComponent BDBNavigator $($this,frame) -auto $valueDS]

	set ($this,value) \
	    [Component::buildNewComponent BDBField $($this,frame) -auto $valueDS "value"]


	grid $($this,drawingFrame) - -sticky news
	grid [Component::getPath $($this,code)] - -sticky news
	grid [Component::getPath $($this,tableScroll)] - -sticky news
	grid [Component::getPath $($this,valueNavigator)] - -sticky ew
	grid [Component::getPath $($this,value)] - -sticky news
	update $this $($this,wf) INIT
    }

    virtual proc update {this observable msg} {
	#puts "ICI $observable modifi, message $msg"
	if {[CharDBWorkflow::hasGlyph $($this,wf)]} {
	    set ($this,code) [CharDBWorkflow::getCurrentGlyphCode $($this,wf)]
	    drawCurrentGlyph $this
	} else {
	    set ($this,code) ""
	}
    }
    
    proc getCurrentGlyphCode {this} {
	return [CharDBWorkflow::getCurrentGlyphCode $($this,wf)]
    }

    # PRIVATE
    proc drawCurrentGlyph {this} {
	set d [DummyDrawer::getDrawer]
	set drawing [CharDBWorkflow::getCurrentSignDrawing $($this,wf)]
	tksesh_defchar tmp $drawing
	seshw::set_text $d tmp
	seshw::autosize $d
	set data  [$d toxbm 1.0 end]
	[getImageName $this] configure -data $data
	
	catch {destroy $($this,drawingFrame).label}
	label $($this,drawingFrame).label -image [getImageName $this]
	pack $($this,drawingFrame).label
	#$p.glyphDraw configure -text "HELLO"
	#$p.glyphDraw configure -image [getImageName $this]
    }

}

namespace eval DummyDrawer {
    variable isLoaded
    set isLoaded 0
    proc getDrawer {} {
	variable isLoaded
	if {! $isLoaded} {
	    set isLoaded 1
	    seshw::create_passive .seshBitmapDrawer -htline 120
	}
	return .seshBitmapDrawer
    }
}
