
# A ContourControlPoint is a ControlPoint which controls a Contour :-)

class ContourControlPoint {

    proc ContourControlPoint {this p owner} \
	    ControlPoint {$p $GraphElt::($owner,window)} {
	set ($this,owner) $owner; # Contour which owns the point
    } 

    proc ~ContourControlPoint {this} {
	set w $GraphElt::($this,window)
    }

    # Action to be taken when the point is moved.

    # moveaction {this x y}

    # Action to be taken when the point is clicked
    
    # proc clickaction {this x y}
    
    # Attach a segment to a point  ?
    # Change from the control function for ControlPoint
    #   the default control function links the point to just one element
    #   this one links the point with the contour.
    
    proc control {this controled} {
  	GraphElt::tagAsMember $this $Segment::($controled,owner)
  	lappend ControlPoint::($this,controled) $controled
    }

    # Unlinked a controled item from the point. If nothing is controled, destroy the point.
    
#      proc detachAndDeleteIfOrphan {this segment} {
#  	detach $this $segment
#  	if {[llength $ContourControlPoint::($this,segments)] == 0} {
#  	    delete $this
#  	}
#      }

    # Unlinked a controled item from the point.

#      proc detach {this segment} {
#  	listreplace ContourControlPoint::($this,segments) $segment
#      }

    # moves the point to x, y.
#      proc move {this x y} {
#  	set p [CharEdit::ongrid $GraphElt::($this,window) $x $y]
#  	set x [Point::x $p]
#  	set y [Point::y $p]
#  	delete $p
#  	$GraphElt::($this,canvas) coords [GraphElt::getDrawing $this] $x $y
#  	foreach i $ContourControlPoint::($this,segments) {
#  	    GraphElt::update $i
#  	}
#      }

#      proc setcoords {this x y} {
#  	move $this $x $y
#      }

#      proc setRed {this} {
	
#      }

#      proc unsetRed {this} {
#      }
    
#      proc createDrawing {this} {
#  	set can $GraphElt::($this,canvas)
#  	set x $Point::($this,x)
#  	set y $Point::($this,y)
#  	set circ [$can create image $x $y -anchor center -image $ContourControlPoint::(image)]
#  	$can addtag ContourControlPoint withtag $circ 
#  	unset Point::($this,x)
#  	unset Point::($this,y)
#  	return $circ
#      }

    proc update {this} {}
    
#      proc x {this} {
#  	set cs [$GraphElt::($this,canvas) coords [GraphElt::getDrawing $this]]
#  	return [lindex $cs 0] 
#      }

#      proc y {this} {
#  	set cs [$GraphElt::($this,canvas) coords [GraphElt::getDrawing $this]]
#  	return [lindex $cs 1]
#      }

    proc middle {this m} {
	set p [Point::middle $this $m]
	set ret [new ContourControlPoint $p $ContourControlPoint::($this,owner)]
	delete $p
	return $ret
    }

#      proc asText {this} {
#  	set c [CharEdit::realPoint $GraphElt::($this,window) $this]
#   	return [format {%.4f %.4f} [lindex $c 0] [lindex $c 1]]
#      }
    
    # deletes a point, but keep the Contour clean
    proc deletePoint {this} {
	set segments [ControlPoint::getControled $this]
	#deletes a control point
	# If the point is an internal control, change the kind of contour.
	if {[llength $segments] == 1 && \
		[Segment::isInternal [lindex $segments 0] $this]} {
	    # Segment::deletePoint $this
	    Segment::change [lindex $segments 0]
	} elseif {[llength $segments] > 1} {
	    Contour::deletePointFrom $ContourControlPoint::($this,owner) $this $segments
	}
    }

#      set ContourControlPoint::(image) [image create bitmap -data {
#  	#define square_width 8
#  	#define square_height 8
#  	static unsigned char square_bits[] = {
#  	    0xff, 0x81, 0x81, 0x81, 0x81, 0x81, 0x81, 0xff, };
#  	} ]
}

