# We should build a simple "line" graphicelt, which would be used by Contour and the others.

class LineGuide {
    proc LineGuide {this window p1 p2} GraphElt {$window} GraphGuide {$window} {
	set ($this,p1) $p1
	set ($this,p2) $p2
	GraphElt::draw $this
	set res [GraphElt::getDrawing $this]
	ControlPoint::control $p1 $this
	ControlPoint::control $p2 $this
	CharEdit::lower $GraphElt::($this,window) $res
    }

    proc ~LineGuide {this} {
	ControlPoint::detachAndDeleteIfOrphan $LineGuide::($this,p1) $this
	ControlPoint::detachAndDeleteIfOrphan $LineGuide::($this,p2) $this
    }

    proc createDrawing {this} {
	set res [eval $GraphElt::($this,canvas) create line [expandPoints $this] \
		-fill [GraphElt::getColor $this]]
	CharEdit::lower $GraphElt::($this,window) $res
	return $res
    }

    proc expandPoints {this} {
	set p1 $LineGuide::($this,p1)
	set p2 $LineGuide::($this,p2)
	return [concat [Point::coords $p1] [Point::coords $p2]]
    }

    proc asText {this} {
	return ""
    }
    
    # virtual proc getColor {this}

    # virtual proc setRed {this} 

    # virtual proc unsetRed {this}

    virtual proc attract {this point} {
	set p1 $LineGuide::($this,p1)
	set p2 $LineGuide::($this,p2)
	set x [Point::x $point]
	set y [Point::y $point]
	set vx [expr [Point::x $p2] - [Point::x $p1]]
	set vy [expr [Point::y $p2] - [Point::y $p1]]
	set n2 [expr $vx*$vx + $vy*$vy]
	if {$n2 == 0.0} return
	# scal is scalar product of p1m and p1p2
	set scal [expr {($x - [Point::x $p1]) * $vx + ($y - [Point::y $p1]) * $vy}]
	set x [expr [Point::x $p1] + $scal * $vx / $n2 ]
	set y [expr [Point::y $p1] + $scal * $vy / $n2 ]
	Point::setcoords $point $x $y
    }
}
