# Classe segments :
# Les Contours " de base ", droits ou splines

class Segment {
    proc Segment {this owner} GraphElt {$GraphElt::($owner,window)} {
	set Segment::($this,owner) $owner
	### Contour::attachSegment  $owner $this NON NON et NON.
	### Les segments ne s'attachent pas n'importe o.
	set Segment::($this,smooth) ""
    }
    
    proc complete_Segment {this} {
	set res [GraphElt::getDrawing $this]
	set can $GraphElt::($this,canvas)
	$can bind $res <Enter> [list GraphElt::setRed $this]
	$can bind $res <Leave> [list GraphElt::unsetRed $this]
	$can bind $res <B1-Motion> [list Segment::moveaction $this %x %y ]
	$can bind $res <B1-ButtonRelease> "Segment::releaseAction $this %x %y; break"
	$can bind $res <Button-1> [list Segment::clickaction $this %x %y ]
	$can bind $res <Shift-Button-1> [list Segment::shiftclickaction $this %x %y ]
    }

    proc ~Segment {this} {
	Contour::detachSegment $Segment::($this,owner) $this 
    }
    
    virtual proc createDrawing {this};	#  creates the drawing form on the canvas.

    proc getColor {this} {
	return [Contour::getColor $Segment::($this,owner)]
    }

    proc draw {this} {
	GraphElt::_draw $this;		# call parent class procedure
	$GraphElt::($this,canvas) addtag [Contour::tagname $Segment::($this,owner)] withtag \
	    [GraphElt::getDrawing $this]
	$GraphElt::($this,canvas) addtag Contourelt withtag [GraphElt::getDrawing $this]
	GraphElt::tagAsMember $this $Segment::($this,owner)
    }

    virtual proc update {this} {
	GraphElt::_update $this
    }

    proc move {this x y} {
	set o $GraphElt::($this,window)
	set w $GraphElt::($this,canvas)
	set s $Segment::($this,owner)
	if $Contour::($s,selected) {
	    $w move selected\
		$CharEdit::($o,dx) $CharEdit::($o,dy)
	} else {
	    $w move [GraphElt::allTagName $s] \
		$CharEdit::($o,dx) $CharEdit::($o,dy)
	}
    }

    virtual proc isInternal {this point} {
	return 0
    }
    
    virtual proc expandPoints {this}

    virtual proc getControlPoints {this}

    virtual proc firstPoint {this} {}
    virtual proc lastPoint {this} {}

    # split --
    # cuts a segment in two at point x y (which should belong to it) :
    virtual proc split {this x y};	
    
    virtual proc double {this};		# cuts a segment in two

    virtual proc ContourControlPoint {this number}; # gets ContourControlPoint number i (starts with 0)

    virtual proc asText {this};		# sends back a textual representation for the element.

    virtual proc change {this};

    proc clickaction {this x y} {
	set editor [GraphElt::getCharEdit $this]
	set state $CharEdit::($editor,state)
	# {delete} {delete $Segment::($this,owner)}
	# {split}  {split $this $x $y}
	# {splinetoline} {change $this}
	# select is not controled by the command system.
	# {lower} {CharEdit::lowerContour $editor $Segment::($this,owner)}
	switch -exact $state {
	    {edit} {CharEdit::makePhoto $editor}
	    {delete} {CharEdit::command $editor [new ContourDeleteCommand $Segment::($this,owner)]}
	    {split} {CharEdit::command $editor [new SegmentSplitCommand $this $x $y]}
	    {splinetoline} {CharEdit::command $editor [new SplineToLineCommand $this]}
	    {select} {Contour::toggleSelect $Segment::($this,owner)}
	    {lower} {CharEdit::command $editor [new LowerCommand $Segment::($this,owner)]}
	    {reverse} {CharEdit::command $editor [new ContourToggleFillCommand $Segment::($this,owner)]}
	}
    }

    proc shiftclickaction {this x y} {
	set editor $GraphElt::($this,window)
	set state $CharEdit::($editor,state)
	switch -exact $state {
	    {lower} {CharEdit::command $editor [new RaiseCommand $Segment::($this,owner)]}
	    default  {CharEdit::command $editor [new SegmentSplitCommand $this $x $y]}
	}
    }

    proc moveaction {this x y} {
	set state $CharEdit::($GraphElt::($this,window),state)
	switch -exact $state {
	    {edit}  {move $this $x $y}
	}
    }

    # Action to be taken when the mouse is released
    
    proc releaseAction {this x y} {
	set editor [GraphElt::getCharEdit $this]
	set state $CharEdit::($editor,state)
	switch -exact $state {
	    {select}  {}
	    {delete} {}
	    {edit} {
		CharEdit::command $editor [new MoveCommand $this $x $y [CharEdit::getPhoto $editor]]
	    }
	}
    }


}
