
class Spline {
    proc Spline {this owner p1 c1 c2 p2} Segment {$owner} {
	ControlPoint::control $p1 $this
	ControlPoint::control $p2 $this
	ControlPoint::control $c1 $this
	ControlPoint::control $c2 $this
	set ($this,p1) $p1
	set ($this,p2) $p2
	set ($this,c1) $c1
	set ($this,c2) $c2
	set Segment::($this,smooth) "-smooth 1"

	
	GraphElt::draw $this

	set res [GraphElt::getDrawing $this]
	CharEdit::lower $GraphElt::($this,window) $res
	Segment::complete_Segment $this
    }
    
    proc ~Spline {this} {
	ControlPoint::detachAndDeleteIfOrphan $Spline::($this,p1) $this
	ControlPoint::detachAndDeleteIfOrphan $Spline::($this,p2) $this
	ControlPoint::detachAndDeleteIfOrphan $Spline::($this,c1) $this
	ControlPoint::detachAndDeleteIfOrphan $Spline::($this,c2) $this
    }


    proc firstPoint {this} {return $Spline::($this,p1)}
    proc lastPoint {this} {return $Spline::($this,p2)}
    proc firstControl {this} {return $Spline::($this,c1)}
    proc secondControl {this} {return $Spline::($this,c2)}

    proc update {this} {
	foreach {main auxline1 auxline2} $GraphElt::($this,drawing) {}
	eval $GraphElt::($this,canvas) coords $main  [expandPoints $this]
	set p1 $Spline::($this,p1)
	set p2 $Spline::($this,p2)
	set c1 $Spline::($this,c1)
	set c2 $Spline::($this,c2)
	eval $GraphElt::($this,canvas) coords $auxline1 [Point::coords $p1] [Point::coords $c1]
	eval $GraphElt::($this,canvas) coords $auxline2 [Point::coords $p2] [Point::coords $c2]
    }

    proc createDrawing {this} {
	set p1 $Spline::($this,p1)
	set p2 $Spline::($this,p2)
	set c1 $Spline::($this,c1)
	set c2 $Spline::($this,c2)
	set res1 [eval $GraphElt::($this,canvas) create line [expandPoints $this] $Segment::($this,smooth)\
		      -fill [GraphElt::getColor $this]] 
	#$GraphElt::($this,canvas) addtag Contourelt withtag $res1 
	set res2 [eval $GraphElt::($this,canvas) create line [Point::coords $p1] [Point::coords $c1]  -fill darkgreen] 
	set res3 [eval $GraphElt::($this,canvas) create line [Point::coords $p2] [Point::coords $c2]  -fill darkgreen]
	CharEdit::lower $GraphElt::($this,window) $res1
	CharEdit::lower $GraphElt::($this,window) $res2
	CharEdit::lower $GraphElt::($this,window) $res3
	return [list $res1 $res2 $res3]
    }

    proc expandPoints {this} {
	set p1 $Spline::($this,p1)
	set p2 $Spline::($this,p2)
	set c1 $Spline::($this,c1)
	set c2 $Spline::($this,c2)
	return [concat [Point::coords $p1] \
		[eval makecurve \
		[Point::coords $p1] \
		[Point::coords $c1] \
		[Point::coords $c2] \
		[Point::coords $p2] \
		3\
		]]
	#  return [concat 
	#  [Point::coords $p1] 
	#  [Point::coords3in4 $p1 $c1] 
	#  		    [Point::coords3in4 $p2 $c2] 
	#  		    [Point::coords $p2] 
	#  		   ]

    }

    proc getControlPoints {this} {
	return [list $($this,p1) $($this,c1) $($this,c2) $($this,p2)]
    }


    # flattenControls --
    # 	returns the list of the control points'coordinates
    proc flattenControls {this} {
	return [concat \
		[Point::coords $Spline::($this,p1)] \
		[Point::coords $Spline::($this,c1)] \
		[Point::coords $Spline::($this,c2)] \
		[Point::coords $Spline::($this,p2)] \
		]
    }

    proc split {this x y} {
	set coords [flattenControls $this]
	set t [SplineAux::point_on_spline $x $y $coords]
	# Get the parameter value for point x,y on the spline
	# or -1 if x,y isn't on the spline
	if {$t != -1} {
	    # get new values for the coordinates
	    set nc [SplineAux::subdivide $coords $t]

	    # o = The contour !
	    set o $Segment::($this,owner)
	    
	    # This is really boring !
	    set a [new Point [lindex $nc 2] [lindex $nc 3]]
	    set b [new Point [lindex $nc 4] [lindex $nc 5]]
	    set c [new Point [lindex $nc 6] [lindex $nc 7]]
	    set d [new Point [lindex $nc 8] [lindex $nc 9]]
	    set e [new Point [lindex $nc 10] [lindex $nc 11]]

	    set pa [new ContourControlPoint $a $o]
	    set pb [new ContourControlPoint $b $o]
	    set pc [new ContourControlPoint $c $o]
	    set pd [new ContourControlPoint $d $o]
	    set pe [new ContourControlPoint $e $o]

	    delete $a
	    delete $b
	    delete $c
	    delete $d
	    delete $e

	    # new splines : p1 pa pb pc and pc pd pe p2

	    # p2 doesn't belong to the current spline any more :
	    set p2 $Spline::($this,p2)
	    ControlPoint::detach $p2 $this

	    # we delete the current spline's control points
	    ControlPoint::detachAndDeleteIfOrphan $Spline::($this,c1) $this
	    ControlPoint::detachAndDeleteIfOrphan $Spline::($this,c2) $this
	    
	    # We set the new control points for the current spline :
	    set ($this,c1) $pa
	    set ($this,c2) $pb
	    set ($this,p2) $pc
	    ControlPoint::control $pa $this
	    ControlPoint::control $pb $this
	    ControlPoint::control $pc $this
	    GraphElt::update $this
	    
	    set newseg [new Spline $Segment::($this,owner) $pc $pd $pe $p2]
	    Contour::replaceSegment $Segment::($this,owner) $this [list $this $newseg]
	}
    }

    proc double {this} {
	set p1 $Spline::($this,p1)
	set p2 $Spline::($this,p2)
	set c1 $Spline::($this,c1)
	set c2 $Spline::($this,c2)

	set o $ContourControlPoint::($p1,owner)
	set a [Point::middle $p1 $c1]
	set b [Point::middle $p2 $c2]
	set d [Point::middle $c1 $c2]
	set e [Point::middle $a $d]
	set f [Point::middle $b $d]
	set g [Point::middle $e $f]
	
	set pa [new ContourControlPoint $a $o]
	set pb [new ContourControlPoint $b $o]
	set pe [new ContourControlPoint $e $o]
	set pf [new ContourControlPoint $f $o]
	set pg [new ContourControlPoint $g $o]

	delete $a
	delete $b
	delete $d
	delete $e
	delete $f
	delete $g

	# new splines : p1 pa pe pg and pg pf pb p2
	# so : exeunt c1 c2que
	
	ControlPoint::detach $p2 $this
	ControlPoint::detachAndDeleteIfOrphan $c1 $this
	ControlPoint::detachAndDeleteIfOrphan $c2 $this
	
	set ($this,c1) $pa
	set ($this,c2) $pe
	set ($this,p2) $pg
	ControlPoint::control $pa $this
	ControlPoint::control $pe $this
	ControlPoint::control $pg $this
	GraphElt::update $this

	set newseg [new Spline $Segment::($this,owner) $pg $pf $pb $p2]
	Contour::replaceSegment $Segment::($this,owner) $this [list $this $newseg]
    }    
    
    proc change {this} {		# returns a line which corresponds to the current element.
	set p1 $Spline::($this,p1)
	set p2 $Spline::($this,p2)
	set c1 $Spline::($this,c1)
	set c2 $Spline::($this,c2)
	set o $Segment::($this,owner)
	set res [new LineSegment $o $p1 $p2]
	Contour::replaceSegment $o $this $res
	delete $this
	return $res
    }

    virtual proc asText {this} {
	return [concat s \
		    [Point::asText $Spline::($this,c1)]\
		    [Point::asText $Spline::($this,c2)]\
		    [Point::asText $Spline::($this,p2)]]
    }
    
    virtual proc isInternal {this point} {
	if {$point == [firstControl $this] || $point == [secondControl $this]} {
	    return 1
	} else {
	    return 0
	}
    }
}
