package require TkseshDB
package require glyphCode
package require ligature
package require BWidget
package require myStoopWidgets

# We work with codes here. This is false, but usable for now.

if {0} {
set db [TkseshDB::getTkseshDB]
TkseshDB::doSelect $db {
    select drawing, code
    from  Glyph, HasCode
    where glyphId = Glyph.oid
    and code glob '[A-Z]*[0-9]*'
    union
    select drawing, PhonCode.code as code
    from Glyph, HasCode, PhonCode
    where
    	glyphId = Glyph.oid
    and PhonCode.sign= HasCode.code
} tmp {
    # Should build a glyph and call getGlyphCode
    # set code "UG$tmp(uid)M$tmp(mid)N$tmp(id)"
    # puts "defining $tmp(code)"
    tksesh_defchar $tmp(code) $tmp(drawing)
}
}

# Signs preloading 



proc preloadSigns {{wantProgress 1}} {
    global progress
    # List computed from frequencies in the Tksesh database,  2003/10/16
    set toPreload {N35 X1 M17 D21 Z1 Z7 G1 G17 I9 Z2 A1 D36 S29 Y1 G43 D46 Z4 Aa1 D2 D54 G7 A2 G41 Q3 V31 D58 V28 I10 D4 O34 O1 N5 V31A W24 R8 Z3 A24 D40 V30 N37 Z3A A40 E34 D37 N29 B1 O4 M23 Z98A G37 N23 N16 Y5 W19 U28 O29 Z5 D35 A42 Z9 N25 Aa13 O49 V13 M3 F34 V20 S34 N35A G36 Y1v P6 M12 Q1 T21 F35 M6 W11 G17A U36 M36 W25 T14 D6 L1 D1 G40 G47 H8 F51 U33 N33 F4 G5 O50 N36 D56 N41 G29 N1 V12 F32 D53 M18 N31 N14 V22 T28 G39 D51 A17 T22 P1 N40 Aa18 M8 F31 Aa2 M22 D28 D52 M2 V4 S43 H6 T30 R4 G28 Z202 N21 F18 Z11 F20 U7 I12 F22 D41 F21 Y3 U1 V6 U15 F27 C7 O39 T3 M4 M16 A12 V1 S3 O6 F26 Aa28 D50 E23 N33A U30 Q7 A19 M1 G14 D34 S12 X4 U23 F13 V29 N26 G4 N6 U5 D55 M40 O44 P8 G35 A14 I6 Aa11 A21 N11 G25 A9 A51 N28 U10 V7 R14 E9 R11 U6 X8 A47 A55 U2 S24 W22 U19 W23 P5 V14 W14 A30 F37B K1 A50 E1 S42 Aa27 X2 A15 E6 L2 D19 N27 A13 A7 U32 F12 F42 Z6 F30 G20 D3 N18 A53 T34 V24 U21 A17A V25 F46 G26 D26 I1 I3 O42 R15 N3 O28 F23 C11 W3 M14 E20 O31 F25 Y2 D20 W17 T18 G54 D60 N34 U17 F40 S38 M20 E21 O36 P4 T19 M26 C2 Z4A W10 T12 Q2 V15 V19 U22 F36 N8 I14 V2 P13 F9 I8 C10 I64 Aa19 U13 K5 X5 M29 Aa17 P3 F47 D57 A52 H6A O24 S20 G21 G30 T31 A35 N2 O35 W10A M24 A26 A28 I5 F39 C2A S28 S32 nTrw G45 D33 R19 O38 F16 G53 A41 G3 Aa20 R12 C12 U3 S23 S33 A4 D43 N17 K4 U29}
   

    set toPreload [lrange $toPreload 0 10]

    set progress 0
    set count 0
    if {$wantProgress} {
	set progress [STopLevel::buildNewTopLevel \
			  SProgressWindow progressbar \
			  [legendes::trans "loading frequent glyphs"]]
    }

    ProgressMeter::setMax $progress [llength $toPreload]
    
    TkseshDB::begin [TkseshDB::getTkseshDB]
    
    foreach s $toPreload {
	hieroglyphs::displayNotFound $s
	if {$wantProgress} {
	    incr count
	    ProgressMeter::notify $progress $count
	}
    }
    
    TkseshDB::commit [TkseshDB::getTkseshDB]
    if {$wantProgress} {
	delete $progress
    }
}



tksesh_unknownSignCommand hieroglyphs::displayNotFound

preloadSigns

ligature::loadLigatures
