# textDAL.tcl --
#	text data access layer
#

#
# 
#  2003 Serge Rosmorduc,
# Universit de Paris 8
#
#
#

#
# 
#

# FUNCTION SUMMARY --

# known public functions are : 
# 	
# DATA SUMMARY -- 

package provide textDAL 1.0

package require TkseshDB

namespace eval textDAL {
    variable VARS
    set VARS(namesDataSource) 0
    
    proc saveText {name txt listOfSigns {refTextOid 0}} {
	set db [TkseshDB::getTkseshDB]
	set uid [TkseshDB::getUid $db]
	set mid [TkseshDB::getMid $db]
	set sid [TkseshDB::getSid $db]
	set name [SQLDB::protectText $name]
	set date [TkseshDB::getDate]
	set type "Text"
	set sid 0
	set comment ""
	set body [SQLDB::protectText $txt]
	set listOfSigns [SQLDB::protectText $listOfSigns]
	set textType "hie"

	set sql "insert into TextView values ($uid,$mid,NULL,$sid,'$date',\
                 $sid,'$name', $refTextOid, '$comment', '$textType', '$body')"
	TkseshDB::update $db $sql
	set id [TkseshDB::getLatestElementID $db $type]
	set subtype "lst"
	set sql "insert into SubText values ($id, '$subtype', '$listOfSigns')"
	TkseshDB::update $db $sql

	refreshAll
	return [list $uid $mid $id $type]
    }

    proc refreshAll {} {
	variable VARS
	if {$VARS(namesDataSource)} {
	    DataSource::refresh $VARS(namesDataSource)
	}
    }
    # truc::fonction --
    # 	description...
    # Parameters:
    # Options:
    # Results:
    # Side Effects:
    # Use:
    #	PUBLIC
    # Called by:

    proc getTextNamesDataSource {} {
	variable VARS
	if {$VARS(namesDataSource) == 0} {
	    set db [TkseshDB::getTkseshDB]
	    set VARS(namesDataSource) \
		[TkseshDB::buildDataSource $db "select oid, name from Text order by lower(name)"]
	    DataSource::refresh $VARS(namesDataSource)
	}
	return $VARS(namesDataSource)
    }

    # Get the OID for a text entry in the text names datasource.
    proc getDSOid {idx} {
	set ds [getTextNamesDataSource]
	return [DataSource::getColIdx $ds $idx "oid"]
    }


    proc getTextFromOid {oid} {
	set db [TkseshDB::getTkseshDB]
	set sql "select body from Text where oid = $oid"
	return [lindex [TkseshDB::select $db $sql] 0]
    }

    
    # calls command for all texts.
    # command is evaluated, and passed :
    # the text oid, name, and list of signs
    proc scanTextsContent {type command} {
	set db [TkseshDB::getTkseshDB]
	set sql "select Text.oid as oid, name, subbody from Text, SubText where textOid= Text.oid and subtype = '$type'"
	TkseshDB::doSelect $db $sql tmp {
	    eval $command [list $tmp(oid) $tmp(name) $tmp(subbody)]
	}
    }

    # Return all texts for a given name.
    
    proc getOidsForName {name} {
	set db [TkseshDB::getTkseshDB]
	set name [TkseshDB::protectText $name]
	set sql "select repOid from TextView where name = '$name'"
	return [TkseshDB::select $db $sql]
    }
}

