package require DBBrowsers
package require myStoopWidgets
package require ligatureEditor
###############################################################################
#			      les menus hiroglyphiques
#set bitmapsd $env(SESHLIB)/Bitmaps


#package require Pbmtoxbm

set namefontes [list \
		    [legendes::trans "Man and his occupations"]\
		    [legendes::trans "Woman and her occupations"]\
		    [legendes::trans "Anthropomorphic Deities"]\
		    [legendes::trans "Parts of the human body"]\
		    [legendes::trans "Mammals"]\
		    [legendes::trans "Parts of Mammals"]\
		    [legendes::trans "Birds"]\
		    [legendes::trans "Parts of Birds"]\
		    [legendes::trans "Amphibious animals, reptiles, etc."]\
		    [legendes::trans "Fishes and parts of fishes"]\
		    [legendes::trans "Invertebrata and lesser animals"]\
		    [legendes::trans "Trees and plants"]\
		    [legendes::trans "Sky, earth, water"]\
		    [legendes::trans "Buildings, parts of buildings, etc."]\
		    [legendes::trans "Ships and parts of ships"]\
		    [legendes::trans "Domestic and funerary furniture"]\
		    [legendes::trans "Temple furniture and sacred emblems"]\
		    [legendes::trans "Crowns, Dress, Staves, etc."]\
		    [legendes::trans "Warfare, hunting, butchery"]\
		    [legendes::trans "Agriculture, crafts, and professions"]\
		    [legendes::trans "Rope, Fibre, baskets, bags, etc."]\
		    [legendes::trans "Vessels of stone and earthenware"]\
		    [legendes::trans "Loaves and cakes"]\
		    [legendes::trans "Writings, games, music"]\
		    [legendes::trans "Strokes"]\
		    [legendes::trans "Unclassified"]\
		   ]

proc quit_menu_glyph {fen keep} {
    grab release $fen
    if {$keep == 1} {
	wm withdraw $fen
    } else {
	destroy $fen
    }                
    focus -force .w.s
}

proc glyphmenucommand {sign fen keep} {
    seshw::plainInsertSign .w.s $sign
    quit_menu_glyph $fen $keep
}

proc glyphinfo {sign fen} {
    $fen.info.signe	configure -text $sign
    set val [hieroglyphs::getAllSignValues $sign]
    $fen.info.val configure -text $val
}

proc fairemenu {nommenu signs keep} {
    #global bitmapsd
    set fen .menusignes$nommenu
    eval [list toplevel $fen]
    eval [wm transient $fen .] 
    
    button $fen.quit -text Cancel \
	    -command [list quit_menu_glyph $fen $keep]
    pack $fen.quit -side left
    set k 1
    TkseshDB::begin [TkseshDB::getTkseshDB]
    foreach i $signs {
	if [expr $k % 8 == 1] then {
	    set maframe $fen.frm$k
	    frame $maframe
	} 
	eval [list button $maframe.w$k -image [hieroglyphs::getBitmapForSign $i] \
		-command [list glyphmenucommand $i $fen $keep]]
        bind $maframe.w$k <FocusIn> [list glyphinfo $i $fen]
        bind $maframe.w$k <Enter> [list glyphinfo $i $fen]

	set topack [append topack "$maframe.w$k "]
	if [expr $k % 8 == 0] then {
	    pack $maframe
	    eval pack $topack -side left
	    set topack ""
	}
	set k [expr $k + 1]
    }
    catch {				# $topack could be empty
    pack $maframe
    eval pack $topack -side left
    }
    frame $fen.info
    pack $fen.info
    label $fen.info.l1 -text sign
    label $fen.info.signe 
    label $fen.info.l2 -text val
    label $fen.info.val
    pack $fen.info.l1 $fen.info.signe $fen.info.l2 $fen.info.val -side left
    TkseshDB::commit [TkseshDB::getTkseshDB]
    return $fen
}

proc fairemenultr {lettre grab} {
    if [winfo exists .menusignes$lettre] {
	wm deiconify .menusignes$lettre
	raise .menusignes$lettre
    } else {
	fairemenu $lettre [hieroglyphs::getAllSignsInSection $lettre] 1 
    }
    if {$grab} {
    focus .menusignes$lettre
    grab set .menusignes$lettre
    }
}

###############################################################################
#                             Glossary

proc ouvrir_glossaire {} {
    if 1 {
	toplevel .gloss
	listbox .gloss.liste -yscroll ".gloss.scroll set" -width 20 -height 20
	scrollbar .gloss.scroll -command ".gloss.liste yview"
	pack .gloss.liste .gloss.scroll -side left -fill both
	seshw::create_editor .gloss.hie -notitle
	label .gloss.lab -textvariable glossvar
	entry .gloss.entry
	pack .gloss.hie .gloss.lab .gloss.entry
	button .gloss.set -text [legendes::trans "Set"] \
		-command {
		    Glossary::setGlossaryEntry [.gloss.entry get] \
			[[seshw::gethwindow .gloss.hie] get 0.0 end]
		    .gloss.liste insert end [.gloss.entry get]
		}
	pack .gloss.set 
	foreach t [Glossary::listEntries] {
	    .gloss.liste insert end $t
	}
    }
}

###############################################################################
#			      Copie des rfrences

proc SESH_insert_ref {} {
    clipboard clear 
    clipboard append [seshw::getref .w]
}

###############################################################################
#			      Recherche de mot

package require seshsearch

proc ouvrir_recherche {} {
    toplevel .reche
    seshsearch::create .reche.g
    grid .reche.g -sticky news
    grid rowconfigure .reche 0 -weight 1
    grid columnconfigure .reche 0 -weight 1
}

package require tradedit

proc ouvrir_traduction {} {
    set w .trad
    toplevel $w -menu .trad.mb
    wm title $w [legendes::trans "Translation editor (Beware, just a model !)"]
    tradedit::createmenu $w.mb .trad
    tradedit::create $w
}

###############################################################################
#			      File loading and saving

set nom_du_fichier ""

proc new_text {w} {
    seshw::clear_text $w.s
    seshw::set_scribe $w [seshuser::getvar NAME]
    seshw::set_scribe_code $w [seshuser::getvar ID]
}

proc executer_commande_fichier {commande nom} {
    global nom_du_fichier
    if {$nom == "" } return
    eval [list $commande $nom]
    set nom_du_fichier $nom
}

proc nom_fichier {quoi commande} {
    global nom_du_fichier
    set patterns {{{MDC file} {.gly .hie}} {Any *}}
    switch $quoi {
	{Load} {
	    set nom [tk_getOpenFile \
		    -defaultextension .hie -filetypes $patterns]
	}
	{Save} {
	    set repertoire [file dirname $nom_du_fichier]
	    set fic [file tail $nom_du_fichier]
	    
	    # Now something strange. tk_getSaveFile -initialfile doesn't work properly
	    # after tk_getOpenFile !

	    if {$nom_du_fichier != "" } {
		     set nom [tk_getSaveFile \
			-initialfile $fic\
			-initialdir $repertoire\
			-defaultextension .hie -filetypes $patterns]
	    } else {
		set nom [tk_getSaveFile \
			-defaultextension .hie -filetypes $patterns]
	    }
	    if {$nom != "" && [file extension $nom] == ""} {
		append nom ".hie"
	    }
	}
    }
    if {$nom != ""} {executer_commande_fichier $commande $nom}
}


proc charger_fichier {fic} {
    set f [open $fic]
    set txt [read $f]
    close $f

    set pb [STopLevel::buildNewTopLevel \
		SProgressWindow progressbar [legendes::trans "Loading text"]]

    TkseshDB::begin [TkseshDB::getTkseshDB]
    catch {seshw::fromtext .w $txt $pb}
    TkseshDB::commit [TkseshDB::getTkseshDB]
    delete $pb
}

proc sauver_fichier {fic} {
    set txt [seshw::totext .w]
    set f [open $fic w]
    set txt [puts $f $txt]
    close $f
}

# Temporary solution.
# We need to build a class 
proc chosetext {} {
    TextDBBrowser::showBrowser
}

# Delete Marked text. Should move to dbbrowse
# (as an option)
proc deleteMyText {w} {
    #set txt [lindex [dbbrowse::getidx $w.l] 1]
    #seshtext::delete $txt
}


# Load all texts in a given directory into the database.

proc insertTextsFromDirectoryIntoDatabase {} {
    set dir [tk_chooseDirectory -mustexist 1]
    set pb [STopLevel::buildNewTopLevel \
		SProgressWindow progressbar [legendes::trans "Importing texts"]]

    set e [seshw::saveDirectory .w $dir $pb]
    foreach l $e {
	puts "error : $l"
    }
    delete $pb
}

#####################################################################
# saving the user's dictionary to a file :

# Currently Obsolete 
proc save_dico {} {
    set patterns {{{dictionary file} {.dic}} {Any *}}
    set name [tk_getSaveFile -defaultextension .dic -filetypes $patterns]
    if {[string compare $name ""] != 0} {
	# Obsolete by now ?
	# Not so. Should be used for updating data.
	# set txt [seshbase::user_dump dico]
	#set f [open $name w]
	#puts $f $txt
	#close $f
    }
}

# Import a dictionary from a file.
proc importUserDictionary {} {
    set patterns {
	{{old dictionary file} {.dic}} 
	{{old dictionary db} {newdic.db}}
	{{text files (Beinlich list)} {.txt}}
	{Any *}}
    set name [tk_getOpenFile -defaultextension .dic -filetypes $patterns]
    
    if {$name eq ""} {
	return
    }
    
    if {[file tail $name] eq "newdic.db"} {
	set dbname [file rootname $name]
	package require Dbinter 
	set db [open_db $dbname r]
	set txt [dump_db $db]
	close_db $db
    } else {
	set f [open $name]
	set txt [read $f]
	close $f
    }
    
    set db [TkseshDB::getTkseshDB]
    TkseshDB::begin $db
    DicoWF::loadOldDicoFile [seshuser::getUID] [seshuser::getMID] $txt
    TkseshDB::commit $db
}

#######################################################################
#
# Dictionary opening and the like
#

proc openDictionary {} {
    set t [DicoBrowser::getDicoBrowser]
    Component::raise $t
}

proc findWordInDictionary {seshw} {
    set current_ref [seshw::getref $seshw]
    clipboard clear 
    clipboard append $current_ref
    
    set hieros [seshw::get_selection $seshw]
    #set tr [translit [seshw::get_selection $seshw -aslist]]
    #set tr [seshw::get_selection $seshw -aslist]
    
    set t [DicoBrowser::getDicoBrowser]
    DicoBrowser::setHieroglyphs $t $hieros
    Component::raise $t
}

#######################################################################

proc openNote {} {
    set t [NoteBrowser::getNoteBrowser]
    Component::raise $t
}

namespace eval Tksesh {

    proc ligatureEdit {} {
	set w .ligatureEditor
	catch {destroy $w}

	toplevel $w
	wm title $w [legendes::trans "Ligatures Editor"]
	ligedit::create $w.f
	ligedit::clear $w.f
	pack $w.f
    }

    proc showText {text coords} {
	set oid [seshtext::getOidForName $text]
	seshw::displayText $oid $coords
    }

    proc showUndefinedSigns {} {
	set w .undefinedSigns 
	toplevel $w
	wm title $w [legendes::trans "Undefined signs"]
	text $w.t -wrap word
	button $w.clear -text [legendes::trans "Clear"] -command {
	    .undefinedSigns.t delete 0.0 end
	    glyphCode::resetUnknown
	}
	$w.t insert insert [lsort [glyphCode::getUnknows]]
	grid $w.t -sticky news
	grid $w.clear
	grid rowconfigure $w 0 -weight 1
	grid columnconfigure $w 0 -weight 1
    }
}