
# REWRITE LIGATURE EDITOR USING THE NEW SIGN FRAMEWORK.

package provide ligatureEditor 1.0

package require seshw
package require seshuser
package require icons
package require ligature

# Startup code for the application. Should move out of this file

#if {! [seshuser::loaduser] } {
#    wm withdraw . 
#    seshuser::dialogue
#    wm deiconify .
#}


#package require stooop
#namespace import stooop::*
#tksesh_unknownSignCommand hieroglyphs::displayNotFound
#ligature::loadLigatures
icons::doIcons
namespace eval ligedit {
    variable VARS
    
    proc create {f} {
	global env

	frame $f

	frame $f.f1
	seshw::create_passive $f.s -width 80

	label $f.f1.l1 -text "nom"	
	entry $f.f1.lig
	grid $f.f1.l1 $f.f1.lig

	frame $f.f2
	
	button $f.f2.b1 -image ::icon::up -command [list ligedit::up $f]
	button $f.f2.b2 -image ::icon::forward -command [list ligedit::right $f]
	button $f.f2.b3 -image ::icon::down -command [list ligedit::down $f]
	button $f.f2.b4 -image ::icon::back -command [list ligedit::left $f]

	grid x $f.f2.b1 x
	grid $f.f2.b4 x $f.f2.b2
	grid x $f.f2.b3 x

	frame $f.f3
	button $f.f3.plus -image ::icon::viewmag+ -command [list ligedit::changesize $f 1]
	button $f.f3.moins -image ::icon::viewmag- -command [list ligedit::changesize $f -1]
	grid $f.f3.plus
	grid $f.f3.moins

	frame $f.f4
	button $f.f4.prev -image ::icon::1leftarrow -command [list ligedit::next $f]
	button $f.f4.next -image ::icon::1rightarrow -command [list ligedit::previous $f]

	label $f.f4.sign -width 4 -relief  sunken
	grid $f.f4.prev $f.f4.sign $f.f4.next 
	
	button $f.save -text "save" -command [list ligedit::save $f]
	grid $f.s  $f.f1 -
	grid ^   $f.f2 $f.f3
	grid $f.save    $f.f4 -

	bind $f.f1.lig <Return> [list ligedit::newlig $f]
	bind $f.s <Button-1> [list ligedit::click $f %x %y]
	return $f
    } 

    # Save the current ligature
    proc save {w} {
	ligature::saveLigature [buildLigatureCommand $w]
    }

    proc click {w x y} {
	puts "click at $x $y"
    }

    proc newlig {w} {
	clear $w
	set t [$w.f1.lig get]
	setlig $w $t
	displayLigature $w
    }

    proc clear {w} {
	variable VARS
	seshw::set_text $w.s ""
	foreach i [array names VARS $w,sign,*] {
	    unset VARS($i)
	}
	#$w.f1.lig configure -text {}
	$w.f4.sign configure -text {}
    }

    proc setlig {w txt} {
	variable VARS
	set VARS($w,lig) $txt
	if {[ligature::exists $txt]} {
	    set l [ligature::getLigature $txt]
	    set VARS($w,size) [lindex $l 0]
	    set i 0
	    foreach {sign x y size} [lrange $l 1 end] {
		puts "$sign $size $x $y"
		set VARS($w,sign,$i,code) $sign
		set VARS($w,sign,$i,size) $size
		set VARS($w,sign,$i,x) $x
		set VARS($w,sign,$i,y) $y
		incr i		
	    }
	} else {
	    set l [split $txt &]
	    set VARS($w,size) [llength $l]
	    set i 0
	    foreach s $l {
		set VARS($w,sign,$i,code) $s
		set VARS($w,sign,$i,size) 100
		set VARS($w,sign,$i,x) 0
		set VARS($w,sign,$i,y) 0
		incr i
	    }
	}
	setsign $w 0
    }

    proc buildLigatureCommand {w} {
	variable VARS
	set n $VARS($w,size)
	set com [list $n]
	for {set i 0} {$i < $n} {incr i} {
	    lappend com $VARS($w,sign,$i,code)
	    lappend com $VARS($w,sign,$i,x)
	    lappend com $VARS($w,sign,$i,y)
	    lappend com $VARS($w,sign,$i,size)
	}
	return $com
    }

    proc setsign {w i} {
	variable VARS
	set VARS($w,curr) $i
	showCurrentSignCode $w
    }

    proc next {w} {
	variable VARS
	set VARS($w,curr) \
	    [expr ( $VARS($w,curr) + 1 ) % $VARS($w,size)]
	showCurrentSignCode $w
    }

    proc previous {w} {
	variable VARS
	set VARS($w,curr) \
	    [expr ( $VARS($w,curr) + 1 ) % $VARS($w,size)]
	showCurrentSignCode $w
    }

    proc delta {w x y} {
	variable VARS
	set i $VARS($w,curr)
	incr VARS($w,sign,$i,x) $x
	incr VARS($w,sign,$i,y) $y
	displayLigature $w
    }

    proc up {w} {
	delta $w 0 1
    }

    proc down {w} {
	delta $w 0 -1
    }

    proc left {w} {
	delta $w -1 0
    }

    proc right {w} {
	delta $w 1 0
    }

    proc changesize {w s} {
	variable VARS
	set i $VARS($w,curr)
	incr VARS($w,sign,$i,size) $s
	displayLigature $w
    }

    proc displayLigature {w} {
	variable VARS
	seshw::set_text $w.s ""
	set c [buildLigatureCommand $w]
	ligature::defineLigature $VARS($w,lig) $c
	seshw::set_text $w.s $VARS($w,lig) 
    }
    
    # display the current sign code.
    proc showCurrentSignCode {w} {
	variable VARS
	set i $VARS($w,curr)
 	$w.f4.sign configure -text $VARS($w,sign,$i,code)
    }
}

#ligedit::create .f
#ligedit::clear .f
#pack .f
