# tag.tcl --
#
#	basic tag manipulation
#
#
# 
#  1999 Serge Rosmorduc,
# quipe EC.art, Laboratoire LRIA, Universit de Paris 8
#
# 15 rue Catulienne
# 93236 St Denis Cedex
# FRANCE
#
# Tout droits rservs.
# 
# voyez le fichier ../LICENCE.txt pour plus d'informations
# See the ../LICENCEE.txt file for more information
#
# $Id: tag.tcl,v 1.1.1.1 2002/04/16 13:55:01 rosmord Exp $
#
#

#
# $Log: tag.tcl,v $
# Revision 1.1.1.1  2002/04/16 13:55:01  rosmord
# Imported using tkCVS
#
#

# FUNCTION SUMMARY --

# known public functions are : 
#	build
#	name
#	value
# 	
# DATA SUMMARY -- 

package provide tag 0.0

# package require bidule

namespace eval tag {
    variable VARS
    namespace export build
    namespace export name
    namespace export value

    # tag::build --
    #	builds a tag
    # Parameters:
    # 	tagname : name of the tag
    #	tagvalue : value of the tag
    # Options:
    # Results:
    #	the tag
    # Side Effects:
    # Use:
    #	PUBLIC
    # Called by:
    
    proc build {tagname tagvalue} {
	return [list $tagname $tagvalue]
    }

    # tag::name --
    #	returns the name of a tag
    # Parameters:
    # 	tag : the tag
    # Options:
    # Results:
    #	the tag's name
    # Side Effects:
    # Use:
    #	PUBLIC
    # Called by:
    
    proc name {tag} {
	return [lindex $tag 0]
    }

    # tag::value --
    #	returns the value of a tag
    # Parameters:
    # 	tag : the tag
    # Options:
    # Results:
    #	the tag's name
    # Side Effects:
    # Use:
    #	PUBLIC
    # Called by:

    proc value {tag} {
	return [lindex $tag 1]
    }
    
}
