package require tclSQLDB
package require myStoopWidgets
package require tablelist
# A widget for Displaying a DataSource's content.

package provide tkDB 1.0

class BDBTableList {

    proc BDBTableList {this parent name dataSource columns args} \
	SimpleComponent {$parent $name $args} \
	Observer {} {
	    set ($this,dataSource) $dataSource
	    PRIVBuildCols $this $columns
	    
    }

    proc ~BDBTableList {this} {
    }
    
    # creatorHook's job is to give this widget a path
    virtual proc creatorHook {this} {
	set options [list -columns $($this,colDecls)]
	set path [Component::getPath $this]
	eval tablelist::tablelist $path $options [Component::getArgs $this]
	Observable::add $($this,dataSource) $this
	
	set body [$path bodypath]
	puts [bind $body <<Button1>>] 
	
	bind $body <Button-1> "BDBTableList::PRIVSelectRow $this %x %y %W"
    }

    # Completor hook's job is to finish the objet, once the path exists.
    virtual proc completorHook {this} {
	refresh $this
	PRIVRefreshIndex $this
    }

    virtual proc update {this observable msg} {
	puts "BDBTableList updating for $msg"
	switch -- $msg {
	    "IndexChanged" {
		PRIVRefreshIndex $this
	    }
	    "ObservableDeleted" {}
	    "dataChanged" -
	    "rowDeleted" {
		refresh $this
		PRIVRefreshIndex $this
	    }
	    "rowChanged" -
	    "rowCreated" {
		puts "getting $msg"
		refresh $this
	    }
	}
    }

    proc refresh {this} {
	set p [Component::getPath $this]
	set ds $($this,dataSource)
	$p delete 0 end
	for {set i 0} {$i < [DataSource::getSize $ds]} {incr i} {
	    set line {}
	    foreach c $($this,columns) {
		lappend line [DataSource::getColIdx $ds $i $c]
	    }
	    $p insert end $line
	}
    }

    # Process column information

    proc PRIVBuildCols {this cols} {
	set ($this,columns) $cols
	set colDecls {}
	foreach c $cols {
	    lappend colDecls 0 $c
	}
	set ($this,colDecls) $colDecls
    }

    proc PRIVRefreshIndex {this} {
	set idx [DataSource::getIndex $($this,dataSource)]
	puts "here $idx"
	set p [Component::getPath $this]
	$p activate $idx
	$p selection clear 0 end
	$p selection set $idx
    }

    proc PRIVSelectRow {this x y W} {
	set xx [expr {$x + [winfo x $W]}]
	set yy [expr {$y + [winfo y $W]}]
	set path [Component::getPath $this]
	set row [$path nearest $yy]
	DataSource::doAction $($this,dataSource) setIndex $row
    }

}